# WEB+DB PRESS Vol.95「機械学習×サーバ管理」サンプルコード

技術評論社刊「WEB+DB PRESS Vol.95」の「機械学習×サーバ管理」（田中慎司著）のサンプルコードです。

いずれも、[Mackerel](https://mackerel.io/)で管理しているサーバを対象としています。

## 線形回帰分析のサンプルコード（`ex1_linear_regression.py`）

次のライブラリを入れる必要があります。

```
pip install numpy
pip install pandas
pip install matplotlib
pip install scipy
pip install scikits.statsmodels
```

MackerelのAPIKEYを設定します。

```
export MACKEREL_APIKEY='Yn8tZr1uel0xYArUEFeRokDKjPEEd8SKRx6ag7qb/7k='
```

サンプルコードを実行します。`<HOSTNAME>`は分析対象のホスト名を入れてください。

```
python ex1_linear_regression.py <HOSTNAME>
```

## 異常検出のサンプルコード（`ex2_anomaly_detection.rb`）

次のライブラリをインストールします。

```
gem install mackerel-client
```

MackerelのAPIKEYを設定します。

```
export MACKEREL_APIKEY='Yn8tZr1uel0xYArUEFeRokDKjPEEd8SKRx6ag7qb/7k='
```

サンプルコードを実行します。`<ORG>`、`<SERVICE>`と`<ROLE>`はそれぞれ分析対象のオーガニゼーション名、サービス名、ロール名を入れてください。ロール名は任意です。

```
ruby ex2_anomaly_detection.rb <ORG> <SERVICE> [<ROLE>]
```
